#include "sys.h"
#include "delay.h"
#include "usart.h"
#include "led.h"
#include "key.h" 
#include "mpu9250.h"
#include "inv_mpu.h"
#include "inv_mpu_dmp_motion_driver.h" 
#include "spi.h"
#include "24l01.h"   
//11ַ 
//c:Ҫ͵ַ
void usart1_send_char(u8 c)
{
	while((USART1->SR&0X40)==0);//ȴһη   
	USART1->DR=c;   	
} 
//ݸλ(V2.6汾)
//fun:. 0XA0~0XAF
//data:ݻ,28ֽ!!
//len:dataЧݸ
void usart1_niming_report(u8 fun,u8*data,u8 len)
{
	u8 send_buf[32];
	u8 i;
	if(len>28)return;	//28ֽ 
	send_buf[len+3]=0;	//У
	send_buf[0]=0X88;	//֡ͷ
	send_buf[1]=fun;	//
	send_buf[2]=len;	//ݳ
	for(i=0;i<len;i++)send_buf[3+i]=data[i];			//
	for(i=0;i<len+3;i++)send_buf[len+3]+=send_buf[i];	//У	
	for(i=0;i<len+4;i++)usart1_send_char(send_buf[i]);	//ݵ1 
}
//ͼٶȴݺ
//aacx,aacy,aacz:x,y,zļٶֵ
//gyrox,gyroy,gyroz:x,y,zֵ
void mpu9250_send_data(short aacx,short aacy,short aacz,short gyrox,short gyroy,short gyroz)
{
	u8 tbuf[12]; 
	tbuf[0]=(aacx>>8)&0XFF;
	tbuf[1]=aacx&0XFF;
	tbuf[2]=(aacy>>8)&0XFF;
	tbuf[3]=aacy&0XFF;
	tbuf[4]=(aacz>>8)&0XFF;
	tbuf[5]=aacz&0XFF; 
	tbuf[6]=(gyrox>>8)&0XFF;
	tbuf[7]=gyrox&0XFF;
	tbuf[8]=(gyroy>>8)&0XFF;
	tbuf[9]=gyroy&0XFF;
	tbuf[10]=(gyroz>>8)&0XFF;
	tbuf[11]=gyroz&0XFF;
	usart1_niming_report(0XA1,tbuf,12);//Զ֡,0XA1
}	
//ͨ1ϱ̬ݸ
//aacx,aacy,aacz:x,y,zļٶֵ
//gyrox,gyroy,gyroz:x,y,zֵ
//roll:.λ0.01ȡ -18000 -> 18000 Ӧ -180.00  ->  180.00
//pitch:.λ 0.01ȡ-9000 - 9000 Ӧ -90.00 -> 90.00 
//yaw:.λΪ0.1 0 -> 3600  Ӧ 0 -> 360.0
void usart1_report_imu(short aacx,short aacy,short aacz,short gyrox,short gyroy,short gyroz,short roll,short pitch,short yaw)
{
	u8 tbuf[28]; 
	u8 i;
	for(i=0;i<28;i++)tbuf[i]=0;//0
	tbuf[0]=(aacx>>8)&0XFF;
	tbuf[1]=aacx&0XFF;
	tbuf[2]=(aacy>>8)&0XFF;
	tbuf[3]=aacy&0XFF;
	tbuf[4]=(aacz>>8)&0XFF;
	tbuf[5]=aacz&0XFF; 
	tbuf[6]=(gyrox>>8)&0XFF;
	tbuf[7]=gyrox&0XFF;
	tbuf[8]=(gyroy>>8)&0XFF;
	tbuf[9]=gyroy&0XFF;
	tbuf[10]=(gyroz>>8)&0XFF;
	tbuf[11]=gyroz&0XFF;	
	tbuf[18]=(roll>>8)&0XFF;
	tbuf[19]=roll&0XFF;
	tbuf[20]=(pitch>>8)&0XFF;
	tbuf[21]=pitch&0XFF;
	tbuf[22]=(yaw>>8)&0XFF;
	tbuf[23]=yaw&0XFF;
	usart1_niming_report(0XAF,tbuf,28);//ɿʾ֡,0XAF
}   



int main(void)
{
	float pitch,roll,yaw; 	        //ŷ
	short aacx,aacy,aacz;	        //ٶȴԭʼ
	short gyrox,gyroy,gyroz;        //ԭʼ 
  
   u8 key;	
	u16 t=0;	
	 u8 mode;
	u8 tmp_buf[33]; 
	delay_init();//ʼʱ
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);// жȼ2
	KEY_Init();
	uart_init(115200);              //ʼUSART
	LED_Init();   	//ʼLED
  NRF24L01_Init();    	//ʼNRF24L01  	
	/*while(mpu_dmp_init())
	{   
 		delay_ms(200);
		LED0=!LED0;//DS0˸ 
	}*/
	mpu_dmp_init();
	while(NRF24L01_Check())	//NRF24L01Ƿλ.	
	{
		printf("NRF24L01 Error\n");
		delay_ms(200);
	}								   
	printf("NRF24L01 OK\n");
	
	
	
	
  while(1)
    {
			
						key=KEY_Scan(0);
					if(key==KEY0_PRES)
					{
						mode=0;   
						break;
					}else if(key==KEY1_PRES)
					{
						mode=1;
						break;
					}
					t++;
					if(t==100)
					{
						printf("KEY0:RX_Mode  KEY1:TX_Mode\n");
						
							delay_ms(1000);
					}
						//LCD_ShowString(10,150,230,16,16,"KEY0:RX_Mode  KEY1:TX_Mode"); //˸ʾʾϢ
					if(t==200)
					{	
						//LCD_Fill(10,150,230,150+16,WHITE);
						t=0; 
					}
					delay_ms(5);	
			
					/*MPU_Get_Accelerometer(&aacx,&aacy,&aacz);	//õٶȴ
					MPU_Get_Gyroscope(&gyrox,&gyroy,&gyroz);	//õ
			    printf("ٶԭʼֵ=%d,%d,%d      ԭʼֵ=%d,%d,%d\r\n",aacx,aacy,aacz,gyrox,gyroy,gyroz);
			  printf("Roll=%d\r\n",-(int)(roll*100));
				printf("Pitch=%d\r\n",(int)(pitch*100));
				printf("Yaw=%d\r\n",-(int)(yaw*10));*/
					
		}
		if(mode==0)//RXģʽ
	{
		//LCD_ShowString(60,150,200,16,16,"NRF24L01 RX_Mode");	
		printf("NRF24L01 RX_Mode\n");
		//LCD_ShowString(60,170,200,16,16,"Received DATA:");	
		printf("Received DATA:\n");
		NRF24L01_RX_Mode();		  
		while(1)
		{	  		    		    				 
			if(NRF24L01_RxPacket(tmp_buf)==0)//һյϢ,ʾ.
			{
				tmp_buf[32]=0;//ַ
				//LCD_ShowString(0,190,239,32,16,tmp_buf); 
				printf("%s\n",tmp_buf);
			}else delay_us(100);	   
			t++;
			if(t==10000)//Լ1sӸıһ״̬
			{
				t=0;
				LED0=!LED0;
			} 				    
		};	
	}else//TXģʽ
	{							    
		//LCD_ShowString(60,150,200,16,16,"NRF24L01 TX_Mode");	
		printf("NRF24L01 TX_Mode\n");
		NRF24L01_TX_Mode();
		mode=' ';//ӿոʼ  
		while(1)
		{	  		   				 
			if(NRF24L01_TxPacket(tmp_buf)==TX_OK)
			{
				//LCD_ShowString(60,170,239,32,16,"Sended DATA:");	
				//LCD_ShowString(0,190,239,32,16,tmp_buf);
				printf("Sended DATA:");
        printf("%s\n",tmp_buf);				
						if(mpu_mpl_get_data(&pitch,&roll,&yaw)==0)
					{
							MPU_Get_Accelerometer(&aacx,&aacy,&aacz);	//õٶȴ
							MPU_Get_Gyroscope(&gyrox,&gyroy,&gyroz);	//õ
						 /*printf("Roll=%d\r\n",-(int)(roll*100));
				printf("Pitch=%d\r\n",(int)(pitch*100));
				printf("Yaw=%d\r\n\r\n",-(int)(yaw*10));*/
						delay_ms(200);
					}
				/*key=mode;
				for(t=0;t<32;t++)
				{
					key++;
					if(key>('~'))key=' ';
					tmp_buf[t]=key;	
				}
				mode++; 
				if(mode>'~')mode=' ';  	  
				tmp_buf[32]=0;//		*/
			for(t=0;t<32;t++)
				{
					
					if(t==0)
					{
						tmp_buf[t]='2 ';
					NRF24L01_TxPacket(tmp_buf);
					}
					if(t==1)
					{
						tmp_buf[t]='3 ';
						NRF24L01_TxPacket(tmp_buf);
					}
				}
				
			}else printf("Send Failed\n");		
			
			LED0=!LED0;
			delay_ms(1500);				    
		};
	} 
}
